diff --git a/doc/bashref.ps b/doc/bashref.ps
index 715e4725..55f780ed 100644
--- a/doc/bashref.ps
+++ b/doc/bashref.ps
@@ -12673,362 +12682,371 @@ Ft(for)30 b(whic)m(h)g(no)g(sp)s(eci\014cation)h(exists,)630
 2580 y(or)f(an)h(error)f(o)s(ccurs)g(adding)g(a)g(completion)i(sp)s
 (eci\014cation.)p eop end
 %%Page: 117 123
-TeXDict begin 117 122 bop 150 -116 a Ft(Chapter)30 b(9:)41
-b(Using)30 b(History)h(In)m(teractiv)m(ely)1925 b(117)150
-299 y Fo(9)80 b(Using)53 b(History)g(In)l(teractiv)l(ely)275
-562 y Ft(This)32 b(c)m(hapter)i(describ)s(es)e(ho)m(w)h(to)h(use)f(the)
-g Fl(gnu)g Ft(History)h(Library)e(in)m(teractiv)m(ely)-8
-b(,)37 b(from)c(a)h(user's)150 671 y(standp)s(oin)m(t.)76
+TeXDict begin 117 122 bop 150 -116 a Ft(Chapter)47 b(9:)i(Using)f
+(History)g(In)m(teractiv)m(ely)1865 b(117)150 299 y Fo(9)80
+b(Using)53 b(History)g(In)l(teractiv)l(ely)275 552 y
+Ft(This)32 b(c)m(hapter)i(describ)s(es)e(ho)m(w)h(to)h(use)f(the)g
+Fl(gnu)g Ft(History)h(Library)e(in)m(teractiv)m(ely)-8
+b(,)37 b(from)c(a)h(user's)150 661 y(standp)s(oin)m(t.)76
 b(It)42 b(should)f(b)s(e)h(considered)g(a)g(user's)g(guide.)76
 b(F)-8 b(or)43 b(information)f(on)g(using)g(the)g Fl(gnu)150
-781 y Ft(History)31 b(Library)f(in)g(other)g(programs,)g(see)h(the)g
-Fl(gnu)f Ft(Readline)h(Library)f(Man)m(ual.)150 1062
+771 y Ft(History)31 b(Library)f(in)g(other)g(programs,)g(see)h(the)g
+Fl(gnu)f Ft(Readline)h(Library)f(Man)m(ual.)150 1044
 y Fr(9.1)68 b(Bash)45 b(History)h(F)-11 b(acilities)275
-1316 y Ft(When)31 b(the)g(`)p Fs(-o)f(history)p Ft(')g(option)i(to)g
+1294 y Ft(When)31 b(the)g(`)p Fs(-o)f(history)p Ft(')g(option)i(to)g
 (the)g Fs(set)f Ft(builtin)g(is)g(enabled)h(\(see)g(Section)g(4.3.1)i
-([The)d(Set)150 1425 y(Builtin],)h(page)g(49\),)h(the)e(shell)h(pro)m
+([The)d(Set)150 1404 y(Builtin],)h(page)g(49\),)h(the)e(shell)h(pro)m
 (vides)f(access)h(to)g(the)f Fq(command)g(history)p Ft(,)h(the)f(list)h
-(of)f(commands)150 1535 y(previously)h(t)m(yp)s(ed.)47
+(of)f(commands)150 1514 y(previously)h(t)m(yp)s(ed.)47
 b(The)33 b(v)-5 b(alue)33 b(of)f(the)h Fs(HISTSIZE)e
 Ft(shell)h(v)-5 b(ariable)34 b(is)f(used)e(as)i(the)g(n)m(um)m(b)s(er)e
-(of)i(com-)150 1644 y(mands)i(to)i(sa)m(v)m(e)h(in)e(a)g(history)h
+(of)i(com-)150 1623 y(mands)i(to)i(sa)m(v)m(e)h(in)e(a)g(history)h
 (list.)58 b(The)36 b(text)h(of)g(the)f(last)h Fs($HISTSIZE)d
-Ft(commands)i(\(default)g(500\))150 1754 y(is)h(sa)m(v)m(ed.)61
+Ft(commands)i(\(default)g(500\))150 1733 y(is)h(sa)m(v)m(ed.)61
 b(The)36 b(shell)h(stores)h(eac)m(h)g(command)e(in)h(the)g(history)g
 (list)g(prior)f(to)i(parameter)f(and)f(v)-5 b(ari-)150
-1864 y(able)33 b(expansion)g(but)f(after)h(history)f(expansion)h(is)g
+1842 y(able)33 b(expansion)g(but)f(after)h(history)f(expansion)h(is)g
 (p)s(erformed,)e(sub)5 b(ject)33 b(to)g(the)g(v)-5 b(alues)33
-b(of)g(the)g(shell)150 1973 y(v)-5 b(ariables)31 b Fs(HISTIGNORE)d
-Ft(and)h Fs(HISTCONTROL)p Ft(.)275 2117 y(When)g(the)g(shell)h(starts)g
+b(of)g(the)g(shell)150 1952 y(v)-5 b(ariables)31 b Fs(HISTIGNORE)d
+Ft(and)h Fs(HISTCONTROL)p Ft(.)275 2093 y(When)g(the)g(shell)h(starts)g
 (up,)f(the)h(history)f(is)h(initialized)h(from)e(the)h(\014le)f(named)g
-(b)m(y)h(the)f Fs(HISTFILE)150 2227 y Ft(v)-5 b(ariable)21
+(b)m(y)h(the)f Fs(HISTFILE)150 2202 y Ft(v)-5 b(ariable)21
 b(\(default)h(`)p Fs(~/.bash_history)p Ft('\).)34 b(The)20
 b(\014le)h(named)f(b)m(y)h(the)g(v)-5 b(alue)21 b(of)g
-Fs(HISTFILE)d Ft(is)j(truncated,)150 2336 y(if)42 b(necessary)-8
+Fs(HISTFILE)d Ft(is)j(truncated,)150 2312 y(if)42 b(necessary)-8
 b(,)45 b(to)e(con)m(tain)g(no)f(more)g(than)f(the)h(n)m(um)m(b)s(er)f
 (of)h(lines)g(sp)s(eci\014ed)f(b)m(y)h(the)g(v)-5 b(alue)42
-b(of)g(the)150 2446 y Fs(HISTFILESIZE)21 b Ft(v)-5 b(ariable.)40
+b(of)g(the)150 2422 y Fs(HISTFILESIZE)21 b Ft(v)-5 b(ariable.)40
 b(When)24 b(an)g(in)m(teractiv)m(e)j(shell)e(exits,)h(the)f(last)g
-Fs($HISTSIZE)d Ft(lines)j(are)f(copied)150 2556 y(from)29
+Fs($HISTSIZE)d Ft(lines)j(are)f(copied)150 2531 y(from)29
 b(the)i(history)e(list)i(to)g(the)f(\014le)g(named)f(b)m(y)h
 Fs($HISTFILE)p Ft(.)38 b(If)30 b(the)g Fs(histappend)d
-Ft(shell)j(option)g(is)g(set)150 2665 y(\(see)22 b(Section)g(4.2)g
+Ft(shell)j(option)g(is)g(set)150 2641 y(\(see)22 b(Section)g(4.2)g
 ([Bash)g(Builtins],)h(page)f(41\),)j(the)c(lines)g(are)h(app)s(ended)d
-(to)j(the)f(history)g(\014le,)j(otherwise)150 2775 y(the)32
+(to)j(the)f(history)g(\014le,)j(otherwise)150 2750 y(the)32
 b(history)f(\014le)g(is)h(o)m(v)m(erwritten.)45 b(If)31
 b Fs(HISTFILE)e Ft(is)j(unset,)f(or)h(if)f(the)h(history)f(\014le)g(is)
-h(un)m(writable,)g(the)150 2884 y(history)37 b(is)h(not)f(sa)m(v)m(ed.)
+h(un)m(writable,)g(the)150 2860 y(history)37 b(is)h(not)f(sa)m(v)m(ed.)
 63 b(After)38 b(sa)m(ving)g(the)f(history)-8 b(,)40 b(the)e(history)f
-(\014le)g(is)h(truncated)f(to)h(con)m(tain)h(no)150 2994
+(\014le)g(is)h(truncated)f(to)h(con)m(tain)h(no)150 2970
 y(more)31 b(than)f Fs($HISTFILESIZE)c Ft(lines.)41 b(If)30
 b Fs(HISTFILESIZE)d Ft(is)k(not)f(set,)h(no)g(truncation)f(is)h(p)s
-(erformed.)275 3138 y(If)g(the)h Fs(HISTTIMEFORMAT)d
+(erformed.)275 3110 y(If)g(the)h Fs(HISTTIMEFORMAT)d
 Ft(is)j(set,)h(the)f(time)h(stamp)f(information)g(asso)s(ciated)i(with)
-e(eac)m(h)h(history)150 3247 y(en)m(try)e(is)f(written)g(to)i(the)e
-(history)g(\014le.)275 3392 y(The)19 b(builtin)h(command)g
-Fs(fc)g Ft(ma)m(y)h(b)s(e)f(used)f(to)i(list)g(or)g(edit)g(and)e
-(re-execute)j(a)f(p)s(ortion)f(of)g(the)h(history)150
-3501 y(list.)41 b(The)27 b Fs(history)f Ft(builtin)i(ma)m(y)h(b)s(e)e
+e(eac)m(h)h(history)150 3220 y(en)m(try)d(is)h(written)f(to)h(the)f
+(history)h(\014le,)f(mark)m(ed)h(with)f(the)g(history)g(commen)m(t)h(c)
+m(haracter.)43 b(When)30 b(the)150 3329 y(history)22
+b(\014le)h(is)g(read,)h(lines)f(b)s(eginning)e(with)i(the)f(history)h
+(commen)m(t)g(c)m(haracter)h(follo)m(w)m(ed)h(immediately)150
+3439 y(b)m(y)30 b(a)h(digit)g(are)g(in)m(terpreted)g(as)f(timestamps)h
+(for)f(the)h(previous)f(history)g(line.)275 3580 y(The)19
+b(builtin)h(command)g Fs(fc)g Ft(ma)m(y)h(b)s(e)f(used)f(to)i(list)g
+(or)g(edit)g(and)e(re-execute)j(a)f(p)s(ortion)f(of)g(the)h(history)150
+3689 y(list.)41 b(The)27 b Fs(history)f Ft(builtin)i(ma)m(y)h(b)s(e)e
 (used)g(to)i(displa)m(y)g(or)f(mo)s(dify)f(the)h(history)g(list)h(and)f
-(manipulate)150 3611 y(the)j(history)g(\014le.)42 b(When)31
+(manipulate)150 3799 y(the)j(history)g(\014le.)42 b(When)31
 b(using)f(command-line)h(editing,)h(searc)m(h)f(commands)g(are)g(a)m(v)
--5 b(ailable)33 b(in)e(eac)m(h)150 3720 y(editing)45
+-5 b(ailable)33 b(in)e(eac)m(h)150 3909 y(editing)45
 b(mo)s(de)g(that)g(pro)m(vide)g(access)h(to)f(the)g(history)f(list)i
 (\(see)f(Section)h(8.4.2)g([Commands)e(F)-8 b(or)150
-3830 y(History],)31 b(page)h(103\).)275 3974 y(The)47
+4018 y(History],)31 b(page)h(103\).)275 4159 y(The)47
 b(shell)i(allo)m(ws)h(con)m(trol)f(o)m(v)m(er)h(whic)m(h)e(commands)g
 (are)h(sa)m(v)m(ed)g(on)f(the)h(history)f(list.)95 b(The)150
-4084 y Fs(HISTCONTROL)25 b Ft(and)j Fs(HISTIGNORE)e Ft(v)-5
+4269 y Fs(HISTCONTROL)25 b Ft(and)j Fs(HISTIGNORE)e Ft(v)-5
 b(ariables)29 b(ma)m(y)h(b)s(e)d(set)j(to)f(cause)g(the)g(shell)f(to)i
-(sa)m(v)m(e)g(only)f(a)g(subset)150 4193 y(of)e(the)g(commands)f(en)m
+(sa)m(v)m(e)g(only)f(a)g(subset)150 4378 y(of)e(the)g(commands)f(en)m
 (tered.)40 b(The)26 b Fs(cmdhist)f Ft(shell)i(option,)h(if)f(enabled,)g
-(causes)h(the)e(shell)h(to)h(attempt)150 4303 y(to)23
+(causes)h(the)e(shell)h(to)h(attempt)150 4488 y(to)23
 b(sa)m(v)m(e)h(eac)m(h)f(line)g(of)f(a)h(m)m(ulti-line)g(command)f(in)g
 (the)h(same)f(history)g(en)m(try)-8 b(,)25 b(adding)d(semicolons)h
-(where)150 4412 y(necessary)37 b(to)f(preserv)m(e)h(syn)m(tactic)h
+(where)150 4597 y(necessary)37 b(to)f(preserv)m(e)h(syn)m(tactic)h
 (correctness.)58 b(The)36 b Fs(lithist)e Ft(shell)i(option)h(causes)g
-(the)f(shell)g(to)150 4522 y(sa)m(v)m(e)25 b(the)e(command)h(with)f(em)
+(the)f(shell)g(to)150 4707 y(sa)m(v)m(e)25 b(the)e(command)h(with)f(em)
 m(b)s(edded)f(newlines)h(instead)h(of)f(semicolons.)40
-b(The)23 b Fs(shopt)e Ft(builtin)i(is)h(used)150 4631
+b(The)23 b Fs(shopt)e Ft(builtin)i(is)h(used)150 4817
 y(to)31 b(set)g(these)g(options.)41 b(See)31 b(Section)g(4.2)g([Bash)g
 (Builtins],)g(page)g(41,)h(for)e(a)h(description)f(of)h
-Fs(shopt)p Ft(.)150 4913 y Fr(9.2)68 b(Bash)45 b(History)h(Builtins)275
-5166 y Ft(Bash)30 b(pro)m(vides)g(t)m(w)m(o)i(builtin)e(commands)g
+Fs(shopt)p Ft(.)150 5090 y Fr(9.2)68 b(Bash)45 b(History)h(Builtins)275
+5340 y Ft(Bash)30 b(pro)m(vides)g(t)m(w)m(o)i(builtin)e(commands)g
 (whic)m(h)g(manipulate)h(the)f(history)h(list)g(and)f(history)g
-(\014le.)150 5340 y Fs(fc)p eop end
+(\014le.)p eop end
 %%Page: 118 124
 TeXDict begin 118 123 bop 150 -116 a Ft(118)2527 b(Bash)31
-b(Reference)g(Man)m(ual)870 299 y Fs(fc)47 b([-e)g Fj(ename)11
-b Fs(])46 b([-lnr])g([)p Fj(first)11 b Fs(])45 b([)p
-Fj(last)11 b Fs(])870 408 y(fc)47 b(-s)g([)p Fj(pat)11
-b Fs(=)p Fj(rep)g Fs(])45 b([)p Fj(command)11 b Fs(])630
-539 y Ft(Fix)41 b(Command.)68 b(In)39 b(the)i(\014rst)e(form,)j(a)e
-(range)h(of)f(commands)g(from)f Fq(\014rst)i Ft(to)g
-Fq(last)i Ft(is)630 648 y(selected)35 b(from)e(the)g(history)g(list.)50
-b(Both)34 b Fq(\014rst)h Ft(and)e Fq(last)j Ft(ma)m(y)e(b)s(e)e(sp)s
-(eci\014ed)h(as)g(a)h(string)630 758 y(\(to)26 b(lo)s(cate)h(the)e
-(most)h(recen)m(t)g(command)e(b)s(eginning)h(with)g(that)g(string\))h
-(or)f(as)g(a)g(n)m(um)m(b)s(er)630 867 y(\(an)f(index)f(in)m(to)h(the)g
-(history)g(list,)h(where)e(a)h(negativ)m(e)i(n)m(um)m(b)s(er)c(is)i
-(used)f(as)g(an)h(o\013set)g(from)630 977 y(the)j(curren)m(t)f(command)
-h(n)m(um)m(b)s(er\).)39 b(If)26 b Fq(last)j Ft(is)e(not)g(sp)s
-(eci\014ed)f(it)h(is)g(set)g(to)h Fq(\014rst)p Ft(.)39
-b(If)26 b Fq(\014rst)i Ft(is)630 1087 y(not)j(sp)s(eci\014ed)f(it)h(is)
-g(set)h(to)f(the)g(previous)f(command)h(for)f(editing)i(and)e
-Fp(\000)p Ft(16)h(for)g(listing.)630 1196 y(If)f(the)g(`)p
-Fs(-l)p Ft(')g(\015ag)h(is)f(giv)m(en,)h(the)g(commands)e(are)i(listed)
-g(on)f(standard)f(output.)40 b(The)30 b(`)p Fs(-n)p Ft(')630
-1306 y(\015ag)i(suppresses)f(the)h(command)g(n)m(um)m(b)s(ers)e(when)i
-(listing.)46 b(The)32 b(`)p Fs(-r)p Ft(')g(\015ag)g(rev)m(erses)h(the)
-630 1415 y(order)g(of)g(the)h(listing.)50 b(Otherwise,)34
-b(the)f(editor)h(giv)m(en)g(b)m(y)f Fq(ename)39 b Ft(is)33
-b(in)m(v)m(ok)m(ed)i(on)e(a)h(\014le)630 1525 y(con)m(taining)i(those)f
-(commands.)52 b(If)33 b Fq(ename)40 b Ft(is)34 b(not)h(giv)m(en,)h(the)
-f(v)-5 b(alue)35 b(of)f(the)g(follo)m(wing)630 1634 y(v)-5
-b(ariable)33 b(expansion)e(is)h(used:)42 b Fs(${FCEDIT:-${EDITOR:-vi}})
-p Ft(.)d(This)31 b(sa)m(ys)h(to)g(use)g(the)630 1744
-y(v)-5 b(alue)34 b(of)f(the)h Fs(FCEDIT)e Ft(v)-5 b(ariable)34
+b(Reference)g(Man)m(ual)150 299 y Fs(fc)870 445 y(fc)47
+b([-e)g Fj(ename)11 b Fs(])46 b([-lnr])g([)p Fj(first)11
+b Fs(])45 b([)p Fj(last)11 b Fs(])870 555 y(fc)47 b(-s)g([)p
+Fj(pat)11 b Fs(=)p Fj(rep)g Fs(])45 b([)p Fj(command)11
+b Fs(])630 701 y Ft(Fix)41 b(Command.)68 b(In)39 b(the)i(\014rst)e
+(form,)j(a)e(range)h(of)f(commands)g(from)f Fq(\014rst)i
+Ft(to)g Fq(last)i Ft(is)630 810 y(selected)35 b(from)e(the)g(history)g
+(list.)50 b(Both)34 b Fq(\014rst)h Ft(and)e Fq(last)j
+Ft(ma)m(y)e(b)s(e)e(sp)s(eci\014ed)h(as)g(a)h(string)630
+920 y(\(to)26 b(lo)s(cate)h(the)e(most)h(recen)m(t)g(command)e(b)s
+(eginning)h(with)g(that)g(string\))h(or)f(as)g(a)g(n)m(um)m(b)s(er)630
+1029 y(\(an)f(index)f(in)m(to)h(the)g(history)g(list,)h(where)e(a)h
+(negativ)m(e)i(n)m(um)m(b)s(er)c(is)i(used)f(as)g(an)h(o\013set)g(from)
+630 1139 y(the)j(curren)m(t)f(command)h(n)m(um)m(b)s(er\).)39
+b(If)26 b Fq(last)j Ft(is)e(not)g(sp)s(eci\014ed)f(it)h(is)g(set)g(to)h
+Fq(\014rst)p Ft(.)39 b(If)26 b Fq(\014rst)i Ft(is)630
+1249 y(not)j(sp)s(eci\014ed)f(it)h(is)g(set)h(to)f(the)g(previous)f
+(command)h(for)f(editing)i(and)e Fp(\000)p Ft(16)h(for)g(listing.)630
+1358 y(If)f(the)g(`)p Fs(-l)p Ft(')g(\015ag)h(is)f(giv)m(en,)h(the)g
+(commands)e(are)i(listed)g(on)f(standard)f(output.)40
+b(The)30 b(`)p Fs(-n)p Ft(')630 1468 y(\015ag)i(suppresses)f(the)h
+(command)g(n)m(um)m(b)s(ers)e(when)i(listing.)46 b(The)32
+b(`)p Fs(-r)p Ft(')g(\015ag)g(rev)m(erses)h(the)630 1577
+y(order)g(of)g(the)h(listing.)50 b(Otherwise,)34 b(the)f(editor)h(giv)m
+(en)g(b)m(y)f Fq(ename)39 b Ft(is)33 b(in)m(v)m(ok)m(ed)i(on)e(a)h
+(\014le)630 1687 y(con)m(taining)i(those)f(commands.)52
+b(If)33 b Fq(ename)40 b Ft(is)34 b(not)h(giv)m(en,)h(the)f(v)-5
+b(alue)35 b(of)f(the)g(follo)m(wing)630 1797 y(v)-5 b(ariable)33
+b(expansion)e(is)h(used:)42 b Fs(${FCEDIT:-${EDITOR:-vi}})p
+Ft(.)d(This)31 b(sa)m(ys)h(to)g(use)g(the)630 1906 y(v)-5
+b(alue)34 b(of)f(the)h Fs(FCEDIT)e Ft(v)-5 b(ariable)34
 b(if)f(set,)i(or)f(the)f(v)-5 b(alue)34 b(of)g(the)f
-Fs(EDITOR)f Ft(v)-5 b(ariable)34 b(if)f(that)630 1854
+Fs(EDITOR)f Ft(v)-5 b(ariable)34 b(if)f(that)630 2016
 y(is)g(set,)i(or)e Fs(vi)g Ft(if)g(neither)g(is)g(set.)50
 b(When)33 b(editing)h(is)f(complete,)i(the)f(edited)f(commands)630
-1963 y(are)e(ec)m(ho)s(ed)g(and)f(executed.)630 2093
+2125 y(are)e(ec)m(ho)s(ed)g(and)f(executed.)630 2271
 y(In)k(the)g(second)g(form,)h Fq(command)j Ft(is)c(re-executed)i(after)
 f(eac)m(h)g(instance)g(of)f Fq(pat)j Ft(in)d(the)630
-2203 y(selected)e(command)e(is)g(replaced)h(b)m(y)g Fq(rep)p
-Ft(.)630 2333 y(A)g(useful)f(alias)i(to)g(use)e(with)h(the)g
+2381 y(selected)e(command)e(is)g(replaced)h(b)m(y)g Fq(rep)p
+Ft(.)630 2527 y(A)g(useful)f(alias)i(to)g(use)e(with)h(the)g
 Fs(fc)f Ft(command)h(is)g Fs(r='fc)e(-s')p Ft(,)h(so)h(that)h(t)m
-(yping)f(`)p Fs(r)f(cc)p Ft(')630 2443 y(runs)35 b(the)h(last)h
+(yping)f(`)p Fs(r)f(cc)p Ft(')630 2637 y(runs)35 b(the)h(last)h
 (command)f(b)s(eginning)g(with)g Fs(cc)f Ft(and)h(t)m(yping)g(`)p
-Fs(r)p Ft(')h(re-executes)h(the)e(last)630 2552 y(command)30
+Fs(r)p Ft(')h(re-executes)h(the)e(last)630 2746 y(command)30
 b(\(see)h(Section)h(6.6)f([Aliases],)h(page)g(77\).)150
-2703 y Fs(history)870 2833 y(history)46 b([)p Fj(n)11
-b Fs(])870 2943 y(history)46 b(-c)870 3052 y(history)g(-d)h
-Fj(offset)870 3162 y Fs(history)f([-anrw])g([)p Fj(filename)11
-b Fs(])870 3271 y(history)46 b(-ps)h Fj(arg)630 3402
+2929 y Fs(history)870 3075 y(history)46 b([)p Fj(n)11
+b Fs(])870 3185 y(history)46 b(-c)870 3294 y(history)g(-d)h
+Fj(offset)870 3404 y Fs(history)f([-anrw])g([)p Fj(filename)11
+b Fs(])870 3513 y(history)46 b(-ps)h Fj(arg)630 3660
 y Ft(With)26 b(no)g(options,)h(displa)m(y)f(the)g(history)g(list)g
 (with)f(line)h(n)m(um)m(b)s(ers.)38 b(Lines)26 b(pre\014xed)e(with)630
-3511 y(a)35 b(`)p Fs(*)p Ft(')g(ha)m(v)m(e)h(b)s(een)e(mo)s(di\014ed.)
+3769 y(a)35 b(`)p Fs(*)p Ft(')g(ha)m(v)m(e)h(b)s(een)e(mo)s(di\014ed.)
 53 b(An)34 b(argumen)m(t)h(of)g Fq(n)f Ft(lists)i(only)f(the)g(last)g
-Fq(n)f Ft(lines.)54 b(If)35 b(the)630 3621 y(shell)30
+Fq(n)f Ft(lines.)54 b(If)35 b(the)630 3879 y(shell)30
 b(v)-5 b(ariable)31 b Fs(HISTTIMEFORMAT)26 b Ft(is)k(set)h(and)e(not)i
 (n)m(ull,)f(it)h(is)f(used)f(as)h(a)h(format)f(string)630
-3730 y(for)36 b Fq(strftime)41 b Ft(to)36 b(displa)m(y)g(the)g(time)h
+3988 y(for)36 b Fq(strftime)41 b Ft(to)36 b(displa)m(y)g(the)g(time)h
 (stamp)f(asso)s(ciated)h(with)f(eac)m(h)h(displa)m(y)m(ed)f(history)630
-3840 y(en)m(try)-8 b(.)47 b(No)33 b(in)m(terv)m(ening)g(blank)f(is)g
+4098 y(en)m(try)-8 b(.)47 b(No)33 b(in)m(terv)m(ening)g(blank)f(is)g
 (prin)m(ted)g(b)s(et)m(w)m(een)h(the)g(formatted)f(time)h(stamp)g(and)
-630 3950 y(the)e(history)f(line.)630 4080 y(Options,)g(if)h(supplied,)e
-(ha)m(v)m(e)i(the)g(follo)m(wing)h(meanings:)630 4230
+630 4208 y(the)e(history)f(line.)630 4354 y(Options,)g(if)h(supplied,)e
+(ha)m(v)m(e)i(the)g(follo)m(wing)h(meanings:)630 4536
 y Fs(-c)384 b Ft(Clear)23 b(the)g(history)g(list.)39
 b(This)22 b(ma)m(y)i(b)s(e)e(com)m(bined)h(with)f(the)h(other)h
-(options)1110 4340 y(to)31 b(replace)g(the)g(history)f(list)h
-(completely)-8 b(.)630 4491 y Fs(-d)30 b Fj(offset)1110
-4600 y Ft(Delete)25 b(the)f(history)f(en)m(try)h(at)g(p)s(osition)f
+(options)1110 4646 y(to)31 b(replace)g(the)g(history)f(list)h
+(completely)-8 b(.)630 4829 y Fs(-d)30 b Fj(offset)1110
+4938 y Ft(Delete)25 b(the)f(history)f(en)m(try)h(at)g(p)s(osition)f
 Fq(o\013set)p Ft(.)39 b Fq(o\013set)27 b Ft(should)22
-b(b)s(e)h(sp)s(eci\014ed)1110 4710 y(as)31 b(it)g(app)s(ears)e(when)h
-(the)g(history)g(is)h(displa)m(y)m(ed.)630 4861 y Fs(-a)384
+b(b)s(e)h(sp)s(eci\014ed)1110 5048 y(as)31 b(it)g(app)s(ears)e(when)h
+(the)g(history)g(is)h(displa)m(y)m(ed.)630 5230 y Fs(-a)384
 b Ft(App)s(end)35 b(the)i(new)g(history)g(lines)g(\(history)g(lines)g
-(en)m(tered)h(since)f(the)g(b)s(e-)1110 4970 y(ginning)30
+(en)m(tered)h(since)f(the)g(b)s(e-)1110 5340 y(ginning)30
 b(of)h(the)f(curren)m(t)g(Bash)h(session\))g(to)g(the)g(history)f
-(\014le.)630 5121 y Fs(-n)384 b Ft(App)s(end)32 b(the)i(history)f
-(lines)h(not)g(already)g(read)g(from)f(the)h(history)f(\014le)h(to)1110
-5230 y(the)26 b(curren)m(t)f(history)g(list.)40 b(These)25
-b(are)h(lines)g(app)s(ended)e(to)i(the)f(history)h(\014le)1110
-5340 y(since)31 b(the)f(b)s(eginning)g(of)g(the)h(curren)m(t)f(Bash)h
-(session.)p eop end
+(\014le.)p eop end
 %%Page: 119 125
 TeXDict begin 119 124 bop 150 -116 a Ft(Chapter)30 b(9:)41
 b(Using)30 b(History)h(In)m(teractiv)m(ely)1925 b(119)630
-299 y Fs(-r)384 b Ft(Read)26 b(the)h(curren)m(t)f(history)g(\014le)g
-(and)g(app)s(end)e(its)j(con)m(ten)m(ts)h(to)f(the)f(history)1110
-408 y(list.)630 571 y Fs(-w)384 b Ft(W)-8 b(rite)32 b(out)e(the)h
-(curren)m(t)f(history)g(to)i(the)e(history)g(\014le.)630
-734 y Fs(-p)384 b Ft(P)m(erform)31 b(history)f(substitution)h(on)f(the)
-h Fq(arg)8 b Ft(s)31 b(and)f(displa)m(y)h(the)f(result)h(on)1110
-843 y(the)d(standard)f(output,)i(without)f(storing)g(the)g(results)g
-(in)g(the)g(history)g(list.)630 1006 y Fs(-s)384 b Ft(The)30
-b Fq(arg)8 b Ft(s)30 b(are)h(added)f(to)h(the)f(end)g(of)h(the)f
-(history)h(list)g(as)f(a)h(single)g(en)m(try)-8 b(.)630
-1168 y(When)24 b(an)m(y)h(of)f(the)h(`)p Fs(-w)p Ft(',)h(`)p
-Fs(-r)p Ft(',)f(`)p Fs(-a)p Ft(',)h(or)f(`)p Fs(-n)p
-Ft(')f(options)g(is)h(used,)g(if)f Fq(\014lename)30 b
-Ft(is)24 b(giv)m(en,)j(then)630 1278 y(it)32 b(is)g(used)f(as)h(the)f
+299 y Fs(-n)384 b Ft(App)s(end)32 b(the)i(history)f(lines)h(not)g
+(already)g(read)g(from)f(the)h(history)f(\014le)h(to)1110
+408 y(the)26 b(curren)m(t)f(history)g(list.)40 b(These)25
+b(are)h(lines)g(app)s(ended)e(to)i(the)f(history)h(\014le)1110
+518 y(since)31 b(the)f(b)s(eginning)g(of)g(the)h(curren)m(t)f(Bash)h
+(session.)630 668 y Fs(-r)384 b Ft(Read)26 b(the)h(curren)m(t)f
+(history)g(\014le)g(and)g(app)s(end)e(its)j(con)m(ten)m(ts)h(to)f(the)f
+(history)1110 778 y(list.)630 928 y Fs(-w)384 b Ft(W)-8
+b(rite)32 b(out)e(the)h(curren)m(t)f(history)g(to)i(the)e(history)g
+(\014le.)630 1078 y Fs(-p)384 b Ft(P)m(erform)31 b(history)f
+(substitution)h(on)f(the)h Fq(arg)8 b Ft(s)31 b(and)f(displa)m(y)h(the)
+f(result)h(on)1110 1188 y(the)d(standard)f(output,)i(without)f(storing)
+g(the)g(results)g(in)g(the)g(history)g(list.)630 1338
+y Fs(-s)384 b Ft(The)30 b Fq(arg)8 b Ft(s)30 b(are)h(added)f(to)h(the)f
+(end)g(of)h(the)f(history)h(list)g(as)f(a)h(single)g(en)m(try)-8
+b(.)630 1488 y(When)24 b(an)m(y)h(of)f(the)h(`)p Fs(-w)p
+Ft(',)h(`)p Fs(-r)p Ft(',)f(`)p Fs(-a)p Ft(',)h(or)f(`)p
+Fs(-n)p Ft(')f(options)g(is)h(used,)g(if)f Fq(\014lename)30
+b Ft(is)24 b(giv)m(en,)j(then)630 1598 y(it)32 b(is)g(used)f(as)h(the)f
 (history)h(\014le.)45 b(If)31 b(not,)h(then)g(the)f(v)-5
 b(alue)32 b(of)g(the)g Fs(HISTFILE)d Ft(v)-5 b(ariable)33
-b(is)630 1388 y(used.)150 1653 y Fr(9.3)68 b(History)46
-b(Expansion)275 1900 y Ft(The)35 b(History)h(library)f(pro)m(vides)h(a)
+b(is)630 1707 y(used.)150 1951 y Fr(9.3)68 b(History)46
+b(Expansion)275 2190 y Ft(The)35 b(History)h(library)f(pro)m(vides)h(a)
 g(history)f(expansion)h(feature)g(that)g(is)g(similar)g(to)g(the)g
-(history)150 2010 y(expansion)22 b(pro)m(vided)f(b)m(y)h
+(history)150 2300 y(expansion)22 b(pro)m(vided)f(b)m(y)h
 Fs(csh)p Ft(.)37 b(This)22 b(section)h(describ)s(es)e(the)h(syn)m(tax)h
-(used)e(to)h(manipulate)h(the)f(history)150 2120 y(information.)275
-2257 y(History)31 b(expansions)f(in)m(tro)s(duce)g(w)m(ords)g(from)g
+(used)e(to)h(manipulate)h(the)f(history)150 2409 y(information.)275
+2539 y(History)31 b(expansions)f(in)m(tro)s(duce)g(w)m(ords)g(from)g
 (the)h(history)f(list)h(in)m(to)g(the)g(input)f(stream,)h(making)150
-2367 y(it)g(easy)g(to)g(rep)s(eat)g(commands,)f(insert)g(the)h(argumen)
+2649 y(it)g(easy)g(to)g(rep)s(eat)g(commands,)f(insert)g(the)h(argumen)
 m(ts)f(to)h(a)g(previous)f(command)g(in)m(to)i(the)e(curren)m(t)150
-2476 y(input)f(line,)i(or)g(\014x)f(errors)f(in)h(previous)g(commands)g
-(quic)m(kly)-8 b(.)275 2614 y(History)27 b(expansion)f(tak)m(es)i
+2759 y(input)f(line,)i(or)g(\014x)f(errors)f(in)h(previous)g(commands)g
+(quic)m(kly)-8 b(.)275 2888 y(History)27 b(expansion)f(tak)m(es)i
 (place)f(in)f(t)m(w)m(o)i(parts.)39 b(The)26 b(\014rst)g(is)g(to)h
-(determine)g(whic)m(h)f(line)h(from)f(the)150 2724 y(history)i(list)g
+(determine)g(whic)m(h)f(line)h(from)f(the)150 2998 y(history)i(list)g
 (should)f(b)s(e)g(used)g(during)g(substitution.)39 b(The)27
 b(second)h(is)g(to)h(select)g(p)s(ortions)e(of)h(that)h(line)150
-2833 y(for)d(inclusion)f(in)m(to)i(the)f(curren)m(t)f(one.)40
+3108 y(for)d(inclusion)f(in)m(to)i(the)f(curren)m(t)f(one.)40
 b(The)25 b(line)h(selected)h(from)f(the)g(history)f(is)h(called)h(the)f
-Fq(ev)m(en)m(t)p Ft(,)j(and)150 2943 y(the)21 b(p)s(ortions)g(of)g
+Fq(ev)m(en)m(t)p Ft(,)j(and)150 3217 y(the)21 b(p)s(ortions)g(of)g
 (that)h(line)f(that)h(are)g(acted)g(up)s(on)e(are)h(called)h
 Fq(w)m(ords)p Ft(.)38 b(V)-8 b(arious)21 b Fq(mo)s(di\014ers)j
-Ft(are)e(a)m(v)-5 b(ailable)150 3052 y(to)35 b(manipulate)f(the)g
+Ft(are)e(a)m(v)-5 b(ailable)150 3327 y(to)35 b(manipulate)f(the)g
 (selected)i(w)m(ords.)51 b(The)33 b(line)h(is)g(brok)m(en)g(in)m(to)h
-(w)m(ords)e(in)h(the)g(same)h(fashion)e(that)150 3162
+(w)m(ords)e(in)h(the)g(same)h(fashion)e(that)150 3436
 y(Bash)i(do)s(es,)h(so)f(that)h(sev)m(eral)g(w)m(ords)e(surrounded)f(b)
 m(y)i(quotes)g(are)g(considered)g(one)g(w)m(ord.)54 b(History)150
-3272 y(expansions)34 b(are)g(in)m(tro)s(duced)f(b)m(y)h(the)g(app)s
+3546 y(expansions)34 b(are)g(in)m(tro)s(duced)f(b)m(y)h(the)g(app)s
 (earance)g(of)g(the)g(history)g(expansion)g(c)m(haracter,)i(whic)m(h)e
-(is)150 3381 y(`)p Fs(!)p Ft(')d(b)m(y)f(default.)41
+(is)150 3656 y(`)p Fs(!)p Ft(')d(b)m(y)f(default.)41
 b(Only)29 b(`)p Fs(\\)p Ft(')i(and)f(`)p Fs(')p Ft(')g(ma)m(y)h(b)s(e)f
 (used)g(to)h(escap)s(e)g(the)f(history)g(expansion)h(c)m(haracter.)275
-3519 y(Sev)m(eral)40 b(shell)g(options)g(settable)h(with)e(the)h
+3785 y(Sev)m(eral)40 b(shell)g(options)g(settable)h(with)e(the)h
 Fs(shopt)e Ft(builtin)h(\(see)h(Section)h(4.2)f([Bash)g(Builtins],)150
-3629 y(page)32 b(41\))h(ma)m(y)f(b)s(e)f(used)g(to)i(tailor)g(the)e(b)s
+3895 y(page)32 b(41\))h(ma)m(y)f(b)s(e)f(used)g(to)i(tailor)g(the)e(b)s
 (eha)m(vior)h(of)g(history)g(expansion.)44 b(If)31 b(the)h
-Fs(histverify)d Ft(shell)150 3738 y(option)39 b(is)f(enabled,)i(and)e
+Fs(histverify)d Ft(shell)150 4005 y(option)39 b(is)f(enabled,)i(and)e
 (Readline)g(is)h(b)s(eing)e(used,)j(history)e(substitutions)g(are)g
-(not)h(immediately)150 3848 y(passed)30 b(to)h(the)g(shell)g(parser.)40
+(not)h(immediately)150 4114 y(passed)30 b(to)h(the)g(shell)g(parser.)40
 b(Instead,)30 b(the)h(expanded)f(line)h(is)f(reloaded)h(in)m(to)h(the)e
-(Readline)h(editing)150 3957 y(bu\013er)e(for)i(further)e(mo)s
+(Readline)h(editing)150 4224 y(bu\013er)e(for)i(further)e(mo)s
 (di\014cation.)41 b(If)30 b(Readline)h(is)f(b)s(eing)g(used,)g(and)g
-(the)g Fs(histreedit)e Ft(shell)i(option)150 4067 y(is)k(enabled,)h(a)g
+(the)g Fs(histreedit)e Ft(shell)i(option)150 4333 y(is)k(enabled,)h(a)g
 (failed)g(history)f(expansion)g(will)g(b)s(e)g(reloaded)g(in)m(to)h
-(the)g(Readline)f(editing)h(bu\013er)e(for)150 4176 y(correction.)74
+(the)g(Readline)f(editing)h(bu\013er)e(for)150 4443 y(correction.)74
 b(The)41 b(`)p Fs(-p)p Ft(')g(option)g(to)h(the)f Fs(history)f
 Ft(builtin)g(command)h(ma)m(y)h(b)s(e)e(used)h(to)g(see)h(what)150
-4286 y(a)c(history)g(expansion)f(will)h(do)f(b)s(efore)h(using)f(it.)63
+4553 y(a)c(history)g(expansion)f(will)h(do)f(b)s(efore)h(using)f(it.)63
 b(The)37 b(`)p Fs(-s)p Ft(')g(option)h(to)h(the)f Fs(history)d
-Ft(builtin)i(ma)m(y)150 4396 y(b)s(e)c(used)h(to)g(add)g(commands)f(to)
+Ft(builtin)i(ma)m(y)150 4662 y(b)s(e)c(used)h(to)g(add)g(commands)f(to)
 i(the)f(end)g(of)g(the)g(history)g(list)h(without)f(actually)i
-(executing)f(them,)150 4505 y(so)j(that)h(they)f(are)g(a)m(v)-5
+(executing)f(them,)150 4772 y(so)j(that)h(they)f(are)g(a)m(v)-5
 b(ailable)40 b(for)e(subsequen)m(t)f(recall.)65 b(This)37
-b(is)h(most)g(useful)g(in)f(conjunction)h(with)150 4615
-y(Readline.)275 4753 y(The)29 b(shell)i(allo)m(ws)h(con)m(trol)g(of)e
-(the)h(v)-5 b(arious)30 b(c)m(haracters)i(used)e(b)m(y)g(the)h(history)
-f(expansion)h(mec)m(ha-)150 4862 y(nism)f(with)g(the)g
-Fs(histchars)e Ft(v)-5 b(ariable.)150 5093 y Fk(9.3.1)63
-b(Ev)m(en)m(t)39 b(Designators)275 5340 y Ft(An)30 b(ev)m(en)m(t)h
-(designator)h(is)e(a)h(reference)g(to)g(a)f(command)h(line)f(en)m(try)h
-(in)f(the)h(history)f(list.)p eop end
+b(is)h(most)g(useful)g(in)f(conjunction)h(with)150 4881
+y(Readline.)275 5011 y(The)33 b(shell)h(allo)m(ws)h(con)m(trol)h(of)e
+(the)g(v)-5 b(arious)34 b(c)m(haracters)h(used)f(b)m(y)f(the)h(history)
+g(expansion)g(mec)m(h-)150 5121 y(anism)h(with)g(the)g
+Fs(histchars)d Ft(v)-5 b(ariable,)38 b(as)d(explained)g(ab)s(o)m(v)m(e)
+i(\(see)f(Section)f(5.2)i([Bash)e(V)-8 b(ariables],)150
+5230 y(page)32 b(59\).)44 b(The)31 b(shell)g(uses)g(the)g(history)g
+(commen)m(t)i(c)m(haracter)f(to)g(mark)f(history)g(timestamps)h(when)
+150 5340 y(writing)e(the)h(history)f(\014le.)p eop end
 %%Page: 120 126
 TeXDict begin 120 125 bop 150 -116 a Ft(120)2527 b(Bash)31
-b(Reference)g(Man)m(ual)150 299 y Fs(!)432 b Ft(Start)34
-b(a)f(history)h(substitution,)g(except)g(when)f(follo)m(w)m(ed)i(b)m(y)
-e(a)h(space,)h(tab,)f(the)g(end)f(of)630 408 y(the)i(line,)g(`)p
-Fs(=)p Ft(')g(or)f(`)p Fs(\()p Ft(')h(\(when)e(the)i
-Fs(extglob)d Ft(shell)j(option)f(is)h(enabled)f(using)g(the)g
-Fs(shopt)630 518 y Ft(builtin\).)150 674 y Fs(!)p Fj(n)384
-b Ft(Refer)30 b(to)i(command)e(line)g Fq(n)p Ft(.)150
-830 y Fs(!-)p Fj(n)336 b Ft(Refer)30 b(to)i(the)e(command)g
-Fq(n)g Ft(lines)h(bac)m(k.)150 985 y Fs(!!)384 b Ft(Refer)30
-b(to)i(the)e(previous)g(command.)40 b(This)30 b(is)g(a)h(synon)m(ym)f
-(for)g(`)p Fs(!-1)p Ft('.)150 1141 y Fs(!)p Fj(string)144
-b Ft(Refer)30 b(to)i(the)e(most)h(recen)m(t)g(command)f(starting)i
-(with)e Fq(string)p Ft(.)150 1297 y Fs(!?)p Fj(string)11
-b Fs([?])630 1406 y Ft(Refer)34 b(to)g(the)f(most)h(recen)m(t)h
-(command)e(con)m(taining)i Fq(string)p Ft(.)50 b(The)33
-b(trailing)i(`)p Fs(?)p Ft(')e(ma)m(y)i(b)s(e)630 1516
-y(omitted)c(if)g(the)f Fq(string)38 b Ft(is)31 b(follo)m(w)m(ed)h
-(immediately)g(b)m(y)e(a)h(newline.)150 1672 y Fs(^)p
-Fj(string1)11 b Fs(^)p Fj(string2)g Fs(^)630 1781 y Ft(Quic)m(k)32
-b(Substitution.)44 b(Rep)s(eat)32 b(the)g(last)h(command,)f(replacing)g
-Fq(string1)40 b Ft(with)31 b Fq(string2)p Ft(.)630 1891
-y(Equiv)-5 b(alen)m(t)31 b(to)g Fs(!!:s/)p Fj(string1)11
-b Fs(/)p Fj(string2)g Fs(/)p Ft(.)150 2047 y Fs(!#)384
-b Ft(The)30 b(en)m(tire)h(command)f(line)h(t)m(yp)s(ed)f(so)h(far.)150
-2265 y Fk(9.3.2)63 b(W)-10 b(ord)41 b(Designators)275
-2508 y Ft(W)-8 b(ord)35 b(designators)g(are)g(used)f(to)h(select)h
-(desired)e(w)m(ords)h(from)f(the)h(ev)m(en)m(t.)55 b(A)34
-b(`)p Fs(:)p Ft(')h(separates)h(the)150 2617 y(ev)m(en)m(t)41
-b(sp)s(eci\014cation)f(from)g(the)f(w)m(ord)g(designator.)69
-b(It)40 b(ma)m(y)g(b)s(e)f(omitted)i(if)e(the)h(w)m(ord)f(designator)
-150 2727 y(b)s(egins)33 b(with)h(a)h(`)p Fs(^)p Ft(',)g(`)p
-Fs($)p Ft(',)g(`)p Fs(*)p Ft(',)h(`)p Fs(-)p Ft(',)f(or)f(`)p
-Fs(\045)p Ft('.)52 b(W)-8 b(ords)35 b(are)f(n)m(um)m(b)s(ered)f(from)g
-(the)i(b)s(eginning)e(of)h(the)g(line,)150 2836 y(with)39
-b(the)h(\014rst)f(w)m(ord)g(b)s(eing)g(denoted)h(b)m(y)g(0)g(\(zero\).)
-70 b(W)-8 b(ords)39 b(are)h(inserted)g(in)m(to)g(the)g(curren)m(t)g
-(line)150 2946 y(separated)31 b(b)m(y)f(single)h(spaces.)275
-3079 y(F)-8 b(or)31 b(example,)150 3234 y Fs(!!)384 b
-Ft(designates)37 b(the)f(preceding)g(command.)57 b(When)35
-b(y)m(ou)i(t)m(yp)s(e)f(this,)h(the)f(preceding)g(com-)630
-3344 y(mand)30 b(is)g(rep)s(eated)g(in)g(toto.)150 3500
-y Fs(!!:$)288 b Ft(designates)23 b(the)g(last)g(argumen)m(t)g(of)f(the)
-h(preceding)f(command.)38 b(This)22 b(ma)m(y)h(b)s(e)e(shortened)630
-3609 y(to)31 b Fs(!$)p Ft(.)150 3765 y Fs(!fi:2)240 b
-Ft(designates)30 b(the)g(second)f(argumen)m(t)h(of)f(the)h(most)f
-(recen)m(t)i(command)e(starting)h(with)f(the)630 3875
-y(letters)j Fs(fi)p Ft(.)275 4030 y(Here)e(are)h(the)g(w)m(ord)f
-(designators:)150 4186 y Fs(0)g(\(zero\))114 b Ft(The)30
-b Fs(0)p Ft(th)g(w)m(ord.)40 b(F)-8 b(or)31 b(man)m(y)g(applications,)h
-(this)e(is)g(the)h(command)f(w)m(ord.)150 4342 y Fj(n)432
-b Ft(The)30 b Fq(n)p Ft(th)g(w)m(ord.)150 4498 y Fs(^)432
-b Ft(The)30 b(\014rst)f(argumen)m(t;)j(that)f(is,)f(w)m(ord)g(1.)150
-4654 y Fs($)432 b Ft(The)30 b(last)h(argumen)m(t.)150
-4809 y Fs(\045)432 b Ft(The)30 b(w)m(ord)g(matc)m(hed)h(b)m(y)f(the)h
+b(Reference)g(Man)m(ual)150 299 y Fk(9.3.1)63 b(Ev)m(en)m(t)39
+b(Designators)275 545 y Ft(An)30 b(ev)m(en)m(t)h(designator)h(is)e(a)h
+(reference)g(to)g(a)f(command)h(line)f(en)m(try)h(in)f(the)h(history)f
+(list.)150 709 y Fs(!)432 b Ft(Start)34 b(a)f(history)h(substitution,)g
+(except)g(when)f(follo)m(w)m(ed)i(b)m(y)e(a)h(space,)h(tab,)f(the)g
+(end)f(of)630 818 y(the)i(line,)g(`)p Fs(=)p Ft(')g(or)f(`)p
+Fs(\()p Ft(')h(\(when)e(the)i Fs(extglob)d Ft(shell)j(option)f(is)h
+(enabled)f(using)g(the)g Fs(shopt)630 928 y Ft(builtin\).)150
+1090 y Fs(!)p Fj(n)384 b Ft(Refer)30 b(to)i(command)e(line)g
+Fq(n)p Ft(.)150 1252 y Fs(!-)p Fj(n)336 b Ft(Refer)30
+b(to)i(the)e(command)g Fq(n)g Ft(lines)h(bac)m(k.)150
+1413 y Fs(!!)384 b Ft(Refer)30 b(to)i(the)e(previous)g(command.)40
+b(This)30 b(is)g(a)h(synon)m(ym)f(for)g(`)p Fs(!-1)p
+Ft('.)150 1575 y Fs(!)p Fj(string)144 b Ft(Refer)30 b(to)i(the)e(most)h
+(recen)m(t)g(command)f(starting)i(with)e Fq(string)p
+Ft(.)150 1737 y Fs(!?)p Fj(string)11 b Fs([?])630 1847
+y Ft(Refer)34 b(to)g(the)f(most)h(recen)m(t)h(command)e(con)m(taining)i
+Fq(string)p Ft(.)50 b(The)33 b(trailing)i(`)p Fs(?)p
+Ft(')e(ma)m(y)i(b)s(e)630 1956 y(omitted)c(if)g(the)f
+Fq(string)38 b Ft(is)31 b(follo)m(w)m(ed)h(immediately)g(b)m(y)e(a)h
+(newline.)150 2118 y Fs(^)p Fj(string1)11 b Fs(^)p Fj(string2)g
+Fs(^)630 2228 y Ft(Quic)m(k)32 b(Substitution.)44 b(Rep)s(eat)32
+b(the)g(last)h(command,)f(replacing)g Fq(string1)40 b
+Ft(with)31 b Fq(string2)p Ft(.)630 2337 y(Equiv)-5 b(alen)m(t)31
+b(to)g Fs(!!:s/)p Fj(string1)11 b Fs(/)p Fj(string2)g
+Fs(/)p Ft(.)150 2499 y Fs(!#)384 b Ft(The)30 b(en)m(tire)h(command)f
+(line)h(t)m(yp)s(ed)f(so)h(far.)150 2729 y Fk(9.3.2)63
+b(W)-10 b(ord)41 b(Designators)275 2975 y Ft(W)-8 b(ord)35
+b(designators)g(are)g(used)f(to)h(select)h(desired)e(w)m(ords)h(from)f
+(the)h(ev)m(en)m(t.)55 b(A)34 b(`)p Fs(:)p Ft(')h(separates)h(the)150
+3085 y(ev)m(en)m(t)41 b(sp)s(eci\014cation)f(from)g(the)f(w)m(ord)g
+(designator.)69 b(It)40 b(ma)m(y)g(b)s(e)f(omitted)i(if)e(the)h(w)m
+(ord)f(designator)150 3194 y(b)s(egins)33 b(with)h(a)h(`)p
+Fs(^)p Ft(',)g(`)p Fs($)p Ft(',)g(`)p Fs(*)p Ft(',)h(`)p
+Fs(-)p Ft(',)f(or)f(`)p Fs(\045)p Ft('.)52 b(W)-8 b(ords)35
+b(are)f(n)m(um)m(b)s(ered)f(from)g(the)i(b)s(eginning)e(of)h(the)g
+(line,)150 3304 y(with)39 b(the)h(\014rst)f(w)m(ord)g(b)s(eing)g
+(denoted)h(b)m(y)g(0)g(\(zero\).)70 b(W)-8 b(ords)39
+b(are)h(inserted)g(in)m(to)g(the)g(curren)m(t)g(line)150
+3413 y(separated)31 b(b)m(y)f(single)h(spaces.)275 3550
+y(F)-8 b(or)31 b(example,)150 3714 y Fs(!!)384 b Ft(designates)37
+b(the)f(preceding)g(command.)57 b(When)35 b(y)m(ou)i(t)m(yp)s(e)f
+(this,)h(the)f(preceding)g(com-)630 3823 y(mand)30 b(is)g(rep)s(eated)g
+(in)g(toto.)150 3985 y Fs(!!:$)288 b Ft(designates)23
+b(the)g(last)g(argumen)m(t)g(of)f(the)h(preceding)f(command.)38
+b(This)22 b(ma)m(y)h(b)s(e)e(shortened)630 4095 y(to)31
+b Fs(!$)p Ft(.)150 4257 y Fs(!fi:2)240 b Ft(designates)30
+b(the)g(second)f(argumen)m(t)h(of)f(the)h(most)f(recen)m(t)i(command)e
+(starting)h(with)f(the)630 4366 y(letters)j Fs(fi)p Ft(.)275
+4529 y(Here)e(are)h(the)g(w)m(ord)f(designators:)150
+4692 y Fs(0)g(\(zero\))114 b Ft(The)30 b Fs(0)p Ft(th)g(w)m(ord.)40
+b(F)-8 b(or)31 b(man)m(y)g(applications,)h(this)e(is)g(the)h(command)f
+(w)m(ord.)150 4854 y Fj(n)432 b Ft(The)30 b Fq(n)p Ft(th)g(w)m(ord.)150
+5016 y Fs(^)432 b Ft(The)30 b(\014rst)f(argumen)m(t;)j(that)f(is,)f(w)m
+(ord)g(1.)150 5178 y Fs($)432 b Ft(The)30 b(last)h(argumen)m(t.)150
+5340 y Fs(\045)432 b Ft(The)30 b(w)m(ord)g(matc)m(hed)h(b)m(y)f(the)h
 (most)g(recen)m(t)g(`)p Fs(?)p Fj(string)11 b Fs(?)p
-Ft(')28 b(searc)m(h.)150 4965 y Fj(x)p Fs(-)p Fj(y)336
-b Ft(A)30 b(range)h(of)g(w)m(ords;)f(`)p Fs(-)p Fj(y)11
-b Ft(')30 b(abbreviates)h(`)p Fs(0-)p Fj(y)11 b Ft('.)150
-5121 y Fs(*)432 b Ft(All)28 b(of)g(the)g(w)m(ords,)g(except)h(the)e
-Fs(0)p Ft(th.)40 b(This)27 b(is)g(a)h(synon)m(ym)f(for)h(`)p
-Fs(1-$)p Ft('.)39 b(It)28 b(is)g(not)g(an)f(error)630
-5230 y(to)j(use)g(`)p Fs(*)p Ft(')f(if)h(there)g(is)g(just)f(one)h(w)m
-(ord)f(in)g(the)h(ev)m(en)m(t;)i(the)d(empt)m(y)i(string)e(is)h
-(returned)e(in)630 5340 y(that)j(case.)p eop end
+Ft(')28 b(searc)m(h.)p eop end
 %%Page: 121 127
 TeXDict begin 121 126 bop 150 -116 a Ft(Chapter)30 b(9:)41
 b(Using)30 b(History)h(In)m(teractiv)m(ely)1925 b(121)150
-299 y Fj(x)11 b Fs(*)373 b Ft(Abbreviates)31 b(`)p Fj(x)p
-Fs(-$)p Ft(')150 458 y Fj(x)p Fs(-)384 b Ft(Abbreviates)31
-b(`)p Fj(x)p Fs(-$)p Ft(')f(lik)m(e)h(`)p Fj(x)11 b Fs(*)p
-Ft(',)31 b(but)e(omits)i(the)g(last)g(w)m(ord.)275 618
-y(If)i(a)h(w)m(ord)g(designator)g(is)g(supplied)f(without)h(an)g(ev)m
-(en)m(t)h(sp)s(eci\014cation,)h(the)e(previous)f(command)150
-727 y(is)d(used)g(as)h(the)f(ev)m(en)m(t.)150 951 y Fk(9.3.3)63
-b(Mo)s(di\014ers)275 1196 y Ft(After)20 b(the)h(optional)h(w)m(ord)f
-(designator,)i(y)m(ou)e(can)g(add)f(a)h(sequence)g(of)g(one)g(or)g
-(more)g(of)g(the)f(follo)m(wing)150 1305 y(mo)s(di\014ers,)29
-b(eac)m(h)j(preceded)e(b)m(y)g(a)h(`)p Fs(:)p Ft('.)150
-1465 y Fs(h)432 b Ft(Remo)m(v)m(e)32 b(a)f(trailing)g(pathname)g(comp)s
-(onen)m(t,)g(lea)m(ving)h(only)e(the)h(head.)150 1624
-y Fs(t)432 b Ft(Remo)m(v)m(e)32 b(all)f(leading)h(pathname)e(comp)s
-(onen)m(ts,)h(lea)m(ving)h(the)e(tail.)150 1783 y Fs(r)432
-b Ft(Remo)m(v)m(e)32 b(a)f(trailing)g(su\016x)f(of)g(the)h(form)f(`)p
-Fs(.)p Fj(suffix)11 b Ft(',)28 b(lea)m(ving)33 b(the)d(basename.)150
-1943 y Fs(e)432 b Ft(Remo)m(v)m(e)32 b(all)f(but)f(the)h(trailing)g
-(su\016x.)150 2102 y Fs(p)432 b Ft(Prin)m(t)30 b(the)h(new)f(command)g
-(but)g(do)g(not)g(execute)i(it.)150 2262 y Fs(q)432 b
-Ft(Quote)31 b(the)f(substituted)g(w)m(ords,)g(escaping)h(further)e
-(substitutions.)150 2421 y Fs(x)432 b Ft(Quote)32 b(the)f(substituted)g
-(w)m(ords)f(as)i(with)f(`)p Fs(q)p Ft(',)h(but)e(break)h(in)m(to)i(w)m
-(ords)d(at)i(spaces,)h(tabs,)630 2531 y(and)d(newlines.)150
-2690 y Fs(s/)p Fj(old)11 b Fs(/)p Fj(new)g Fs(/)630 2800
-y Ft(Substitute)32 b Fq(new)40 b Ft(for)32 b(the)h(\014rst)f(o)s
-(ccurrence)h(of)f Fq(old)37 b Ft(in)32 b(the)h(ev)m(en)m(t)h(line.)48
-b(An)m(y)32 b(delimiter)630 2909 y(ma)m(y)25 b(b)s(e)g(used)f(in)g
-(place)i(of)f(`)p Fs(/)p Ft('.)39 b(The)24 b(delimiter)h(ma)m(y)h(b)s
-(e)e(quoted)h(in)f Fq(old)29 b Ft(and)24 b Fq(new)32
-b Ft(with)25 b(a)630 3019 y(single)k(bac)m(kslash.)40
-b(If)28 b(`)p Fs(&)p Ft(')g(app)s(ears)g(in)f Fq(new)p
-Ft(,)i(it)f(is)h(replaced)f(b)m(y)g Fq(old)p Ft(.)40
-b(A)28 b(single)h(bac)m(kslash)630 3128 y(will)35 b(quote)g(the)g(`)p
-Fs(&)p Ft('.)54 b(The)34 b(\014nal)g(delimiter)i(is)e(optional)i(if)f
-(it)g(is)f(the)h(last)h(c)m(haracter)g(on)630 3238 y(the)31
-b(input)e(line.)150 3397 y Fs(&)432 b Ft(Rep)s(eat)31
-b(the)f(previous)g(substitution.)150 3557 y Fs(g)150
-3666 y(a)432 b Ft(Cause)38 b(c)m(hanges)i(to)f(b)s(e)f(applied)h(o)m(v)
-m(er)h(the)f(en)m(tire)g(ev)m(en)m(t)h(line.)66 b(Used)39
-b(in)f(conjunction)630 3776 y(with)30 b(`)p Fs(s)p Ft(',)h(as)f(in)h
-Fs(gs/)p Fj(old)11 b Fs(/)p Fj(new)g Fs(/)p Ft(,)26 b(or)k(with)h(`)p
-Fs(&)p Ft('.)150 3935 y Fs(G)432 b Ft(Apply)30 b(the)g(follo)m(wing)i
-(`)p Fs(s)p Ft(')f(mo)s(di\014er)e(once)i(to)g(eac)m(h)h(w)m(ord)e(in)g
-(the)g(ev)m(en)m(t.)p eop end
+299 y Fj(x)p Fs(-)p Fj(y)336 b Ft(A)30 b(range)h(of)g(w)m(ords;)f(`)p
+Fs(-)p Fj(y)11 b Ft(')30 b(abbreviates)h(`)p Fs(0-)p
+Fj(y)11 b Ft('.)150 458 y Fs(*)432 b Ft(All)28 b(of)g(the)g(w)m(ords,)g
+(except)h(the)e Fs(0)p Ft(th.)40 b(This)27 b(is)g(a)h(synon)m(ym)f(for)
+h(`)p Fs(1-$)p Ft('.)39 b(It)28 b(is)g(not)g(an)f(error)630
+568 y(to)j(use)g(`)p Fs(*)p Ft(')f(if)h(there)g(is)g(just)f(one)h(w)m
+(ord)f(in)g(the)h(ev)m(en)m(t;)i(the)d(empt)m(y)i(string)e(is)h
+(returned)e(in)630 677 y(that)j(case.)150 837 y Fj(x)11
+b Fs(*)373 b Ft(Abbreviates)31 b(`)p Fj(x)p Fs(-$)p Ft(')150
+996 y Fj(x)p Fs(-)384 b Ft(Abbreviates)31 b(`)p Fj(x)p
+Fs(-$)p Ft(')f(lik)m(e)h(`)p Fj(x)11 b Fs(*)p Ft(',)31
+b(but)e(omits)i(the)g(last)g(w)m(ord.)275 1156 y(If)i(a)h(w)m(ord)g
+(designator)g(is)g(supplied)f(without)h(an)g(ev)m(en)m(t)h(sp)s
+(eci\014cation,)h(the)e(previous)f(command)150 1265 y(is)d(used)g(as)h
+(the)f(ev)m(en)m(t.)150 1489 y Fk(9.3.3)63 b(Mo)s(di\014ers)275
+1733 y Ft(After)20 b(the)h(optional)h(w)m(ord)f(designator,)i(y)m(ou)e
+(can)g(add)f(a)h(sequence)g(of)g(one)g(or)g(more)g(of)g(the)f(follo)m
+(wing)150 1843 y(mo)s(di\014ers,)29 b(eac)m(h)j(preceded)e(b)m(y)g(a)h
+(`)p Fs(:)p Ft('.)150 2002 y Fs(h)432 b Ft(Remo)m(v)m(e)32
+b(a)f(trailing)g(pathname)g(comp)s(onen)m(t,)g(lea)m(ving)h(only)e(the)
+h(head.)150 2162 y Fs(t)432 b Ft(Remo)m(v)m(e)32 b(all)f(leading)h
+(pathname)e(comp)s(onen)m(ts,)h(lea)m(ving)h(the)e(tail.)150
+2321 y Fs(r)432 b Ft(Remo)m(v)m(e)32 b(a)f(trailing)g(su\016x)f(of)g
+(the)h(form)f(`)p Fs(.)p Fj(suffix)11 b Ft(',)28 b(lea)m(ving)33
+b(the)d(basename.)150 2481 y Fs(e)432 b Ft(Remo)m(v)m(e)32
+b(all)f(but)f(the)h(trailing)g(su\016x.)150 2640 y Fs(p)432
+b Ft(Prin)m(t)30 b(the)h(new)f(command)g(but)g(do)g(not)g(execute)i
+(it.)150 2800 y Fs(q)432 b Ft(Quote)31 b(the)f(substituted)g(w)m(ords,)
+g(escaping)h(further)e(substitutions.)150 2959 y Fs(x)432
+b Ft(Quote)32 b(the)f(substituted)g(w)m(ords)f(as)i(with)f(`)p
+Fs(q)p Ft(',)h(but)e(break)h(in)m(to)i(w)m(ords)d(at)i(spaces,)h(tabs,)
+630 3068 y(and)d(newlines.)150 3228 y Fs(s/)p Fj(old)11
+b Fs(/)p Fj(new)g Fs(/)630 3337 y Ft(Substitute)32 b
+Fq(new)40 b Ft(for)32 b(the)h(\014rst)f(o)s(ccurrence)h(of)f
+Fq(old)37 b Ft(in)32 b(the)h(ev)m(en)m(t)h(line.)48 b(An)m(y)32
+b(delimiter)630 3447 y(ma)m(y)25 b(b)s(e)g(used)f(in)g(place)i(of)f(`)p
+Fs(/)p Ft('.)39 b(The)24 b(delimiter)h(ma)m(y)h(b)s(e)e(quoted)h(in)f
+Fq(old)29 b Ft(and)24 b Fq(new)32 b Ft(with)25 b(a)630
+3557 y(single)k(bac)m(kslash.)40 b(If)28 b(`)p Fs(&)p
+Ft(')g(app)s(ears)g(in)f Fq(new)p Ft(,)i(it)f(is)h(replaced)f(b)m(y)g
+Fq(old)p Ft(.)40 b(A)28 b(single)h(bac)m(kslash)630 3666
+y(will)35 b(quote)g(the)g(`)p Fs(&)p Ft('.)54 b(The)34
+b(\014nal)g(delimiter)i(is)e(optional)i(if)f(it)g(is)f(the)h(last)h(c)m
+(haracter)g(on)630 3776 y(the)31 b(input)e(line.)150
+3935 y Fs(&)432 b Ft(Rep)s(eat)31 b(the)f(previous)g(substitution.)150
+4095 y Fs(g)150 4204 y(a)432 b Ft(Cause)38 b(c)m(hanges)i(to)f(b)s(e)f
+(applied)h(o)m(v)m(er)h(the)f(en)m(tire)g(ev)m(en)m(t)h(line.)66
+b(Used)39 b(in)f(conjunction)630 4314 y(with)30 b(`)p
+Fs(s)p Ft(',)h(as)f(in)h Fs(gs/)p Fj(old)11 b Fs(/)p
+Fj(new)g Fs(/)p Ft(,)26 b(or)k(with)h(`)p Fs(&)p Ft('.)150
+4473 y Fs(G)432 b Ft(Apply)30 b(the)g(follo)m(wing)i(`)p
+Fs(s)p Ft(')f(mo)s(di\014er)e(once)i(to)g(eac)m(h)h(w)m(ord)e(in)g(the)
+g(ev)m(en)m(t.)p eop end
 %%Page: 122 128
 TeXDict begin 122 127 bop 150 -116 a Ft(122)2527 b(Bash)31
 b(Reference)g(Man)m(ual)p eop end
